package fse.eclipse.mergehelper.ui;

import java.util.List;

import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.jtool.changereplayer.ui.SourceCodeControl;
import org.jtool.changereplayer.ui.SourceCodeView;
import org.jtool.changerepository.data.FileInfo;
import org.jtool.changerepository.operation.UnifiedOperation;

public class MH_SourceCodeControl extends SourceCodeControl {
    public MH_SourceCodeControl(SourceCodeView view) {
        super(view);
    }

    @Override
    public void update() {
        FileInfo fInfo = sourcecodeView.getFileInfo();
        int idx = sourcecodeView.getCurrentOperationIndex();
        int mergeIdx = MH_HistoryView.getInstance().getAMergeIndex();
        if (fileInfo != null && fileInfo.equals(fInfo)) {
            if ((mergeIdx != -1 && idx < mergeIdx && mergeIdx >= 0) || currentCode == null) {
                currentCode = fInfo.getCode(idx);
            } else {
                currentCode = fInfo.getCode(currentCode, prevCodeIndex, idx);
            }
        } else {
            currentCode = fInfo.getCode(idx);
        }

        fileInfo = fInfo;
        prevCodeIndex = idx;

        if (currentCode == null) {
            System.out.println("### Error occurred during the replay = " + (idx + 1));
            return;
        }

        setText(currentCode);
        decorateCode(currentCode);
    }

    @Override
    protected void decorateCode(String code) {
        StyledText styledText = getStyledText();
        styledText.setStyleRange(null);
        reset();

        List<StyleRange> ranges = getColoredStyleRanges(code);
        int startOffset = -1;
        if (ranges.size() > 0) {
            startOffset = ranges.get(0).start;
        } else {
            List<UnifiedOperation> ops = sourcecodeView.getFileInfo().getOperations();
            int idx = sourcecodeView.getCurrentOperationIndex();
            if (0 <= idx && idx < ops.size()) {
                UnifiedOperation op = ops.get(idx);
                int start = op.getStart();
                if (start != -1) {
                    startOffset = start;
                }
            }
        }

        for (StyleRange range : ranges) {
            styledText.setStyleRange(range);
        }

        reveal(startOffset, code);
    }
}
